/* Projekt 1. - TPI 
   Autor: Dawid Pichen
   e-mail: dawidpichen@klub.chip.pl
*/

#include <stdio.h>
#include "czas.h"
#include "tab.h"

int main (void)
{ unsigned int liczba, rozmiary[] = {10, 50, 100, 500, 1000, 2500, 5000, 7500, 10000, 15000, 20000, 30000, 40000, 50000, 60000, 70000, 80000, 90000, 100000, 0 };
unsigned char i, indeks=0;
struct timeval start, stop; //struktura timeval okrelona w plikach naglwkowych jdra
Tablica tab1, kopia;
float czasy_babelkowe[L_PROB], czasy_wstawianie[L_PROB], czasy_qs[L_PROB], czasy_kopiec[L_PROB];
FILE *plik;

if (!(plik=fopen("wynik.txt","w"))) { 
	printf("\a\nWystpi bd otwarcia pliku do zapisu!");
	return 1;
}
fprintf(plik, "Legenda: B - sortowanie bbelkowe, W - sortowania przez wstawanie,\nK - sortowanie przez kopcowanie, Q - sortowanie QuickSort.\n");
srand(time(0));
while (rozmiary[indeks])	//gwna ptla programu, badajca algorytmy sortowania dla rozmiarw tablic umieszczonych w tablicy rozmiary
{ printf("\n##### Rozmiar tablicy %u #####", rozmiary[indeks]);
if (alokuj(&tab1, rozmiary[indeks]) && alokuj(&kopia, rozmiary[indeks])) 
	printf("\nPami zostaa przydzielona dla tablicy gwnej i jej kopii...");
    	else { printf("\a\nBd alokacji pamici!");
		return 1;
	}

for (i=0; i<L_PROB; i++)	//L_PROB zdefiniowane w czas.h
	{ printf("\n*** Prba nr %d ***",i); 
	wypelnij(tab1); //wypelniam tablice wartosciami losowymi...
	kopiuj(tab1, kopia);  //kopiuje zawartosc tablicy...
	
	gettimeofday(&start, NULL);
	sort_babelkowe(tab1);
	gettimeofday(&stop, NULL);
	czasy_babelkowe[i] = roznica(start, stop);
	printf("\nCzas tr. oper. sort. dla algor. sortowania bbelkowego: %f sekund.",czasy_babelkowe[i]);
	
	kopiuj(kopia, tab1); //przywracam zawartosc tablicy...
	gettimeofday(&start, NULL);
	sort_przez_wstawianie(tab1);
	gettimeofday(&stop, NULL);
	czasy_wstawianie[i] = roznica(start, stop);
	printf("\nCzas tr. oper. sort. dla algor. sort. przez wstawianie: %f sekund.",czasy_wstawianie[i]);
	
	kopiuj(kopia, tab1); //przywracam zawartosc tablicy...
	gettimeofday(&start, NULL);
	sort_kopiec(tab1);
	gettimeofday(&stop, NULL);
	czasy_kopiec[i] = roznica(start, stop);
	printf("\nCzas trwania operacji sort. dla kopcowego algor. sort.: %f sekund.",czasy_kopiec[i]);
	
	kopiuj(kopia, tab1); //przywracam zawartosc tablicy...
	gettimeofday(&start, NULL);
	sort_qs(tab1);
	gettimeofday(&stop, NULL);
	czasy_qs[i] = roznica(start, stop);
	printf("\nCzas  trwania operacji  sort. dla  algorytmu Quicksort: %f sekund.",czasy_qs[i]);
	};
printf("\n\n***** CZASY REDNIE SORTOWA DLA TABLICY %u ELEMENTOWEJ *****",rozmiary[indeks]);
printf("\nDla algor. sortowania bbelkowego: %f sekund.",srednia(czasy_babelkowe));
printf("\nDla algor. sort. przez wstawianie: %f sekund.",srednia(czasy_wstawianie));
printf("\nDla kopcowego algorytmu sortowania: %f sekund.",srednia(czasy_kopiec));
printf("\nDla algorytmu Quicksort: %f sekund.\n",srednia(czasy_qs));
fprintf(plik, "\nN = %u:\nB %f s\nW %f s\nK %f s\nQ %f s",rozmiary[indeks],srednia(czasy_babelkowe),srednia(czasy_wstawianie),srednia(czasy_kopiec),srednia(czasy_qs));
zwolnij(&tab1);  
zwolnij(&kopia);  
indeks++;
}
fprintf(plik, "\n\n(C) 2005 Dawid Pichen.");
fclose(plik);
return 0;
} 

